## csound 5.14.2~dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project (Csound)

message(STATUS "${CMAKE_HOME_DIRECTORY}")

# Project definitions
set(APIVERSION "5.2")

# Relative install paths
set(EXECUTABLE_INSTALL_DIR "bin")
set(LIBRARY_INSTALL_DIR "lib")
if(USE_DOUBLE)
    set(PLUGIN_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/csound/plugins64-${APIVERSION}")
else()
    set(PLUGIN_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/csound/plugins-${APIVERSION}")
endif()
set(PYTHON_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR})
set(JAVA_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR})
set(LUA_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR})

# Include this after the install path definitions so we can override them here.
find_file(CUSTOM_CMAKE "Custom.cmake" HINTS ${CMAKE_HOME_DIRECTORY})
if(CUSTOM_CMAKE)
    message(STATUS "Including Custom.cmake file: ${CUSTOM_CMAKE}")
    include(${CUSTOM_CMAKE})
endif()

include(TestBigEndian)
include(CheckFunctionExists)

# Utility function to make plugins. All plugin targets should use this as it
# sets up output directory set in top-level CmakeLists.txt
# and adds the appropriate install target
#
# libname - name of library to produce
# srcs - list of src files (must be quoted if a list)
# extralibs (OPTIONAL) - extra libraries to link the plugin to
#  
function(make_plugin libname srcs)
    if(APPLE)
        add_library(${libname} SHARED ${srcs})
    else()
        add_library(${libname} MODULE ${srcs})
    endif()

    set(i 2)
    while( ${i} LESS ${ARGC} )
        if(NOT MSVC OR NOT("${ARGV${i}}" MATCHES "m"))
            target_link_libraries(${libname} ${ARGV${i}})
        endif()
        math(EXPR i "${i}+1")
    endwhile()
    
    set_target_properties(${libname} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})

    install(TARGETS ${libname}
	LIBRARY DESTINATION "${PLUGIN_INSTALL_DIR}" )
endfunction(make_plugin)
# Utility function to make executables. All plugin targets should use this as it
# sets up output directory set in top-level CmakeLists.txt
# and adds an appropriate install target
#
# name - name of executable to produce
# srcs - list of src files
# libs - list of library files to link to
# output_name (OPTIONAL) - overide the name of the generated executable
#
function(make_executable name srcs libs) 
    add_executable(${name} ${srcs})
    target_link_libraries (${name} ${libs})
    set_target_properties(${name} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR})

    if(${ARGC} EQUAL 4) 
        set_target_properties(${name} PROPERTIES            
            OUTPUT_NAME ${ARGV3})
    endif()
    install(TARGETS ${name}
	RUNTIME DESTINATION "${EXECUTABLE_INSTALL_DIR}" )
endfunction(make_executable)


# Utility function to make a utility executable
#
# name - name of executable to produce
# srcs - list of src files

function(make_utility name srcs)
    make_executable(${name} "${srcs}" "${CSOUNDLIB}")
    add_dependencies(${name} ${CSOUNDLIB}) 
endfunction()


# Expands a list into a space-separated string (outvar element1 ....)
# Why do I have to do this? Cmake, you just lost one point
function(expand_list out)
    set(i 1)
    set(tmp "")
    while( ${i} LESS ${ARGC} )
        set(tmp "${tmp} ${ARGV${i}}")
        math(EXPR i "${i}+1")
    endwhile()
    set(${out} "${tmp}" PARENT_SCOPE)
endfunction(expand_list)

# Checks if dependencies for an enabled target are fulfilled.
# If FAIL_MISSING is true and the dependencies are not fulfilled,
# it will abort the cmake run.
# If FAIL_MISSING is false, it will set the option to OFF.
# If the target is not enabled, it will do nothing.
# example: check_deps(BUILD_NEW_PARSER FLEX_EXECUTABLE BISON_EXECUTABLE)
function(check_deps option)
    if(${option})
        set(i 1)
        while( ${i} LESS ${ARGC} )
            set(dep ${ARGV${i}})
            if(NOT ${dep})
                if(FAIL_MISSING)
                    message(FATAL_ERROR
                        "${option} is enabled, but ${dep}=\"${${dep}}\"")
                else()
                    message(STATUS "${dep}=\"${${dep}}\", so disabling ${option}")
                    set(${option} OFF PARENT_SCOPE)
                    # Set it in the local scope too
                    set(${option} OFF)
                endif()
            endif()
            math(EXPR i "${i}+1")
        endwhile()
    endif()
    if(${option})
        message(STATUS "${option} is enabled")
    else()
        message(STATUS "${option} is disabled")
    endif()
endfunction(check_deps)

if(WIN32 AND NOT MSVC)
    if(EXISTS "C:/MinGW/include")
        include_directories(C:/MinGW/include)
    else()
        MESSAGE(STATUS "MinGW include dir not found")
    endif()
endif()

if(WIN32)
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
    set(CMAKE_SHARED_MODULE_PREFIX "")
    
    set(CSOUND_WINDOWS_LIBRARIES 
        advapi32 
        comctl32 
        comdlg32 
        glu32 
        kernel32 
        msvcrt
        odbc32 
        odbccp32 
        ole32 
        oleaut32 
        shell32             
        user32 
        uuid             
        winmm 
        winspool 
        ws2_32 
        wsock32 
        advapi32 
        comctl32 
        comdlg32 
        glu32 
        kernel32 
        odbc32 
        odbccp32 
        ole32 
        oleaut32 
        shell32             
        user32 
        uuid             
        winmm 
        winspool 
        ws2_32 
        wsock32
        pthread)
    
endif(WIN32)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(LINUX YES)
else()
    set(LINUX NO)
endif()

## USER OPTIONS ##

option(USE_DOUBLE "Set to use double-precision floating point for audio samples." ON)
option(BUILD_UTILITIES "Build stand-alone executables for utilities that can also be used with -U" ON)

option(BUILD_NEW_PARSER "Enable building new parser (requires Flex/Bison)" ON)
option(NEW_PARSER_DEBUG "Enable tracing of new parser" OFF)

option(BUILD_MULTI_CORE "Enable building for multicore system (requires BUILD_NEW_PARSER)" OFF)

option(FAIL_MISSING "Fail when a required external dependency is not present (useful for packagers)" OFF)

 # Optional targets, they should all default to ON (check_deps will disable them if not possible to build)


set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

# This needs to be here since _everybody_ needs this flag
if(USE_DOUBLE) 
    add_definitions("-DUSE_DOUBLE")
endif(USE_DOUBLE)
if(${CMAKE_C_COMPILER} MATCHES "gcc" AND LINUX)
    add_definitions("-fvisibility=hidden")
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX) 
    add_definitions("-Wno-format")
endif()

#if(USE_DOUBLE)
#    set(BUILD_PLUGINS_DIR ${BUILD_DIR}/plugins64)
#else()
#    set(BUILD_PLUGINS_DIR ${BUILD_DIR}/plugins)
#endif()

set(BUILD_PLUGINS_DIR ${BUILD_DIR})
set(BUILD_BIN_DIR ${BUILD_DIR})
set(BUILD_LIB_DIR ${BUILD_DIR})

message(STATUS "BUILD_BIN_DIR set to ${BUILD_BIN_DIR}")
message(STATUS "BUILD_LIB_DIR set to ${BUILD_LIB_DIR}")
message(STATUS "BUILD_PLUGINS_DIR set to ${BUILD_PLUGINS_DIR}")

# OS specific checks

TEST_BIG_ENDIAN(BIG_ENDIAN)

## CONFIGURATION ##

SET(BUILD_SHARED_LIBS ON)

## HEADER/LIBRARY/OTHER CHECKS ##

# First, required stuff
find_library(LIBSNDFILE_LIBRARY sndfile)
if(NOT LIBSNDFILE_LIBRARY)
    message(FATAL_ERROR "Csound requires the sndfile library")
endif()

find_path(SNDFILE_H_PATH sndfile.h)
if(SNDFILE_H_PATH)
    include_directories(${SNDFILE_H_PATH})
else()
    message(FATAL_ERROR "Could not find sndfile.h") 
endif()

find_library(PTHREAD_LIBRARY pthread)

if(NOT PTHREAD_LIBRARY AND WIN32)   
    find_library(PTHREAD_LIBRARY pthreadGC2)
endif()

if(NOT PTHREAD_LIBRARY)
    message(FATAL_ERROR "Csound requires the pthread library")
endif()

set(CMAKE_REQUIRED_INCLUDES pthread.h)
set(CMAKE_REQUIRED_LIBRARIES pthread)

# Now, non required library searches #

find_library(VORBISFILE_LIBRARY vorbisfile)
find_file(USE_GETTEXT libintl.h)
find_library(LIBINTL_LIBRARY intl)

set(HEADERS_TO_CHECK 
    unistd.h io.h fcntl.h stdint.h
    sys/time.h sys/types.h termios.h
    values.h winsock.h sys/socket.h
    dirent.h)

foreach(header ${HEADERS_TO_CHECK})
    # Convert to uppercase and replace [./] with _
    string(TOUPPER ${header} tmp)
    string(REGEX REPLACE [./] "_" upper_header ${tmp})
    find_file(HAVE_${upper_header} ${header})
endforeach()

# Flex/Bison for the new parser
if(BUILD_NEW_PARSER)
    find_package(FLEX)
    find_package(BISON)
endif()

## MAIN TARGETS ##

set(libcsound_CFLAGS -D__BUILDING_LIBCSOUND)

include_directories(./H)
include_directories(./Engine)
 
#adding this for files that #include SDIF/sdif*
include_directories(./)

#checking pthread functions
check_function_exists(pthread_spin_lock PTHREAD_SPIN_LOCK_EXISTS)
check_function_exists(pthread_barrier_init PTHREAD_BARRIER_INIT_EXISTS)

if(PTHREAD_SPIN_LOCK_EXISTS)
   list(APPEND libcsound_CFLAGS -DHAVE_PTHREAD_SPIN_LOCK)
endif()

if(PTHREAD_BARRIER_INIT_EXISTS)
   list(APPEND libcsound_CFLAGS -DHAVE_PTHREAD_BARRIER_INIT)
endif()



#if(WIN32)
    include_directories(${LIBSNDFILE_INCLUDE_DIRECTORY})
#endif(WIN32)


# The csound library
set(libcsound_SRCS
    Engine/auxfd.c
    Engine/cfgvar.c
    Engine/entry1.c
    Engine/envvar.c
    Engine/express.c
    Engine/extract.c
    Engine/fgens.c
    Engine/insert.c
    Engine/linevent.c
    Engine/memalloc.c
    Engine/memfiles.c
    Engine/musmon.c
    Engine/namedins.c
    Engine/otran.c
    Engine/rdorch.c
    Engine/rdscor.c
    Engine/scsort.c
    Engine/scxtract.c
    Engine/sort.c
    Engine/sread.c
    Engine/swrite.c
    Engine/twarp.c
    InOut/libsnd.c
    InOut/libsnd_u.c
    InOut/midifile.c
    InOut/midirecv.c
    InOut/midisend.c
    InOut/winascii.c
    InOut/windin.c
    InOut/window.c
    InOut/winEPS.c
    OOps/aops.c
    OOps/bus.c
    OOps/cmath.c
    OOps/diskin.c
    OOps/diskin2.c
    OOps/disprep.c
    OOps/dumpf.c
    OOps/fftlib.c
    OOps/goto_ops.c
    OOps/midiinterop.c
    OOps/midiops.c
    OOps/midiout.c
    OOps/mxfft.c
    OOps/oscils.c
    OOps/pstream.c
    OOps/pvfileio.c
    OOps/pvsanal.c
    OOps/random.c
    OOps/remote.c
    OOps/schedule.c
    OOps/sndinfUG.c
    OOps/str_ops.c
    OOps/ugens1.c
    OOps/ugens2.c
    OOps/ugens3.c
    OOps/ugens4.c
    OOps/ugens5.c
    OOps/ugens6.c
    OOps/ugrw1.c
    OOps/ugrw2.c
    OOps/vdelay.c
    Top/argdecode.c
    Top/cscore_internal.c
    Top/cscorfns.c
    Top/csmodule.c
    Top/csound.c
    Top/getstring.c
    Top/main.c
    Top/new_opts.c
    Top/one_file.c
    Top/opcode.c
    Top/threads.c
    Top/utility.c)

# Handling New Parser

check_deps(BUILD_NEW_PARSER FLEX_EXECUTABLE BISON_EXECUTABLE)
if(BUILD_NEW_PARSER)
    add_custom_target(NewParser echo "Creating parser.c")

    set(YACC_SRC ${CMAKE_CURRENT_SOURCE_DIR}/Engine/csound_orc.y)
    set(YACC_OUT ${CMAKE_CURRENT_BINARY_DIR}/csound_orcparse.c)

    set(LEX_SRC ${CMAKE_CURRENT_SOURCE_DIR}/Engine/csound_orc.l)
    set(LEX_OUT ${CMAKE_CURRENT_BINARY_DIR}/csound_orclex.c)

    add_custom_command(
        SOURCE ${LEX_SRC}
        COMMAND ${FLEX_EXECUTABLE} ARGS -Pcsound_orc -o${LEX_OUT} ${LEX_SRC}
        TARGET NewParser
        OUTPUTS ${LEX_OUT})

    add_custom_command(
        SOURCE ${YACC_SRC}
        COMMAND ${BISON_EXECUTABLE}
        ARGS -pcsound_orc -d --report=itemset -o ${YACC_OUT} ${YACC_SRC} 
        TARGET NewParser
        DEPENDS ${LEX_OUT}
        OUTPUTS ${YACC_OUT})
    
    list(APPEND libcsound_SRCS 
                ${LEX_OUT} ${YACC_OUT}
                Engine/csound_orc_semantics.c
                Engine/csound_orc_expressions.c
                Engine/csound_orc_optimize.c
                Engine/csound_orc_compile.c
                Engine/new_orc_parser.c
                Engine/symbtab.c)

    set_source_files_properties(${YACC_OUT} GENERATED)
    set_source_files_properties(${LEX_OUT} GENERATED)

    include_directories(${CMAKE_CURRENT_BINARY_DIR})
    
    list(APPEND libcsound_CFLAGS -DENABLE_NEW_PARSER)

=== SConstruct ===
#J vim:syntax=python
print '''
      C S O U N D 5

SCons build file for Csound 5:
API library, plugin opcodes, utilities, and front ends.

By Michael Gogins <gogins at pipeline dot com>

For custom options, run 'scons -h'.
For default options, run 'scons -H'.
If headers or libraries are not found, edit 'custom.py'.
For Linux, run in the standard shell
    with standard Python and just run 'scons'.
For MinGW, run in the MSys shell
    and use www.python.org WIN32 Python to run scons.
For Microsoft Visual C++, run in the Platform SDK
    command shell, and use www.python.org WIN32 Python to run scons.
'''

import time
import glob
import os
import os.path
import sys
import string
import shutil
import copy

#############################################################################
#
#   UTILITY FUNCTIONS
#
#############################################################################

pluginLibraries = []
executables = []
headers = Split('''
    H/cfgvar.h H/cscore.h H/csdl.h H/csound.h H/csound.hpp H/csoundCore.h
    H/cwindow.h H/msg_attr.h H/OpcodeBase.hpp H/pstream.h H/pvfileio.h
    H/soundio.h H/sysdep.h H/text.h H/version.h H/float-version.h
    interfaces/CsoundFile.hpp interfaces/CppSound.hpp interfaces/filebuilding.h
''')
libs = []
pythonModules = []

def today():
    return time.strftime("%Y-%m-%d", time.localtime())

# Detect OPERATING SYSTEM platform.

def getPlatform():
    if sys.platform[:5] == 'linux':
        return 'linux'
    elif sys.platform[:3] == 'win':
        return 'win32'
    elif sys.platform[:6] == 'darwin':
        return 'darwin'
    elif sys.platform[:5] == 'sunos':
        return 'sunos'
    else:
        return 'unsupported'

#############################################################################
#
#   DEFINE CONFIGURATION
#
#############################################################################

print "System platform is '" + getPlatform() + "'."


# Create options that can be set from the command line.

commandOptions = Options()
commandOptions.Add('CC')
commandOptions.Add('CXX')
commandOptions.Add('LINK')
commandOptions.Add('LINKFLAGS')
commandOptions.Add('custom',
    'Specify name of custom options file (default is "custom.py")',
    'custom.py')
commandOptions.Add('useDouble',
    'Set to 1 to use double-precision floating point for audio samples.',
    '0')
commandOptions.Add('usePortAudio',
    'Set to 1 to use PortAudio for real-time audio input and output.',
    '1')
commandOptions.Add('usePortMIDI',
    'Build PortMidi plugin for real time MIDI input and output.',
    '1')
commandOptions.Add('useALSA',
    'Set to 1 to use ALSA for real-time audio and MIDI input and output.',
    '1')
commandOptions.Add('useJack',
    'Set to 1 if you compiled PortAudio to use Jack; also builds Jack plugin.',
    '1')
commandOptions.Add('useFLTK',
    'Set to 1 to use FLTK for graphs and widget opcodes.',
    '1')
commandOptions.Add('noFLTKThreads',
    'Set to 1 to disable use of a separate thread for FLTK widgets.',
    '1')
commandOptions.Add('pythonVersion',
    'Set to the Python version to be used.',
    '%d.%d' % (int(sys.hexversion) >> 24, (int(sys.hexversion) >> 16) & 255))
commandOptions.Add('buildCsoundVST',
    'Set to 1 to build CsoundVST (needs CsoundAC, FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsoundAC',
    'Set to 1 to build CsoundAC (needs FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsound5GUI',
    'Build FLTK GUI frontend (requires FLTK 1.1.7 or later).',
    '0')
commandOptions.Add('generateTags',
    'Set to 1 to generate TAGS',
    '0')
commandOptions.Add('generatePdf',
    'Set to 1 to generate PDF documentation',
    '0')
commandOptions.Add('buildLoris',
    'Set to 1 to build the Loris Python extension and opcodes',
    '1')
commandOptions.Add('useOSC',
    'Set to 1 if you want OSC support',
    '0')
commandOptions.Add('bufferoverflowu',
    'Set to 1 to use the Windows buffer overflow library, required if you use MinGW to link with MSVC-built libraries',
    '0')
if getPlatform() != 'win32':
    commandOptions.Add('useUDP',
        'Set to 0 if you do not want UDP support',
        '1')
else:
    commandOptions.Add('useUDP',
        'Set to 1 if you want UDP support',
        '0')
commandOptions.Add('buildPythonOpcodes',
    'Set to 1 to build Python opcodes',
    '0')
commandOptions.Add('buildLuaOpcodes',
    'Set to 1 to build Lua opcodes',
    '0')
commandOptions.Add('prefix',
    'Base directory for installs. Defaults to /usr/local.',
    '/usr/local')
commandOptions.Add('instdir',
    'For the install target: puts instdir before the prefix',
    '')
commandOptions.Add('buildRelease',
    'Set to 1 to build for release (implies noDebug).',
    '0')
commandOptions.Add('noDebug',
    'Build without debugging information.',
    '0')
commandOptions.Add('gcc3opt',
    'Enable gcc 3.3.x or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('gcc4opt',
    'Enable gcc 4.0 or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('useLrint',
    'Use lrint() and lrintf() for converting floating point values to integers.',
    '0')
commandOptions.Add('useGprof',
    'Build with profiling information (-pg).',
    '0')
commandOptions.Add('Word64',
    'Build for 64bit computer',
    '0')
commandOptions.Add('Lib64',
    'Build for lib64 rather than lib',
    '0')
if getPlatform() == 'win32':
    commandOptions.Add('dynamicCsoundLibrary',
        'Set to 0 to build static Csound library instead of csound.dll',
        '1')
else:
    commandOptions.Add('dynamicCsoundLibrary',
        'Build dynamic Csound library instead of libcsound.a',
        '0')
commandOptions.Add('buildStkOpcodes',
    "Build opcodes encapsulating Perry Cook's Synthesis Toolkit in C++ instruments and effects",
    '0')
commandOptions.Add('install',
    'Enables the Install targets',
    '0')
commandOptions.Add('buildPDClass',
    "build csoundapi~ PD class (needs m_pd.h in the standard places)",
    '0')
commandOptions.Add('useCoreAudio',
    "Set to 1 to use CoreAudio for real-time audio input and output.",
    '1')
commandOptions.Add('useAltivec',
    "On OSX use the gcc AltiVec optmisation flags",
    '0')
commandOptions.Add('buildDSSI',
    "Build DSSI/LADSPA host opcodes",
    '1')
commandOptions.Add('buildUtilities',
    "Build stand-alone executables for utilities that can also be used with -U",
    '1')
commandOptions.Add('buildTclcsound',
    "Build Tclcsound frontend (cstclsh, cswish and tclcsound dynamic module). Requires Tcl/Tk headers and libs",
    '0')
commandOptions.Add('buildWinsound',
    "Build Winsound frontend. Requires FLTK headers and libs",
    '0')
commandOptions.Add('buildVirtual',
    "Build Virtual MIDI keyboard. Requires FLTK 1.1.7 or later headers and libs",
    '0')
commandOptions.Add('buildInterfaces',
    "Build C++ interface library.",
    '0')
commandOptions.Add('buildLuaWrapper',
    'Set to 1 to build Lua wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildPythonWrapper',
    'Set to 1 to build Python wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildJavaWrapper',
    'Set to 1 to build Java wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildOSXGUI',
    'On OSX, set to 1 to build the basic GUI frontend',
    '0')
commandOptions.Add('buildCSEditor',
    'Set to 1 to build the Csound syntax highlighting text editor. Requires FLTK headers and libs',
    '0')
commandOptions.Add('withICL',
    'On Windows, set to 1 to build with the Intel C++ Compiler (also requires Microsoft Visual C++), or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withMSVC',
    'On Windows, set to 1 to build with Microsoft Visual C++, or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withSunStudio',
    'On Solaris, set to 1 to build with Sun Studio, or set to 0 to build with gcc',
    '1')
commandOptions.Add('buildNewParser',
    'Enable building new parser (requires Flex/Bison)',
    '1')
commandOptions.Add('NewParserDebug',
    'Enable tracing of new parser',
    '0')
commandOptions.Add('buildMultiCore',
    'Enable building for multicore sytem (requires new parser)',
    '1')
commandOptions.Add('buildvst4cs',
    'Set to 1 to build vst4cs plugins (requires Steinberg VST headers)',
    '0')
if getPlatform() == 'win32':
  commandOptions.Add('useGettext',
    'Set to 1 to use the GBU internationalisation/localisation scheme',
    '0')
else:
  commandOptions.Add('useGettext',
    'Set to 0 for none and 1 for GNU internationalisation/localisation scheme',
    '1')
commandOptions.Add('buildImageOpcodes',
    'Set to 0 to avoid building image opcodes',
    '1')
commandOptions.Add('useOpenMP',
    'Set to 1 to use OpenMP for parallel performance',
    '0')
commandOptions.Add('tclversion',
    'Set to 8.4 or 8.5',
    '8.5')
commandOptions.Add('includeMP3',
     'Set to 1 if using mpadec',
     '0')
commandOptions.Add('includeWii',
     'Set to 1 if using libwiimote',
     '0')
commandOptions.Add('includeP5Glove',
     'Set to 1 if using P5 Glove',
     '0')
commandOptions.Add('buildBeats',
     'Set to 1 if building beats score language',
     '0')
commandOptions.Add('buildcatalog',
     'Set to 1 if building opcode/library catalogue',
     '0')
commandOptions.Add('includeSerial',
     'Set to 1 if compiling serial code',
     '0')
# Define the common part of the build environment.
# This section also sets up customized options for third-party libraries, which
# should take priority over default options.

commonEnvironment = Environment(ENV = os.environ)
commandOptions.Update(commonEnvironment)

def compilerIntel():
    if getPlatform() == 'win32' and commonEnvironment['withICL'] == '1':
        return True
    else:
        return False

def compilerMicrosoft():
    if getPlatform() == 'win32' and commonEnvironment['withMSVC'] == '1':
        return True
    else:
        return False

def compilerSun():
    if getPlatform() == 'sunos' and commonEnvironment['withSunStudio'] == '1':
        return True
    else:
        return False

def compilerGNU():
    if not compilerIntel() and not compilerMicrosoft() and not compilerSun():
        return True
    else:
        return False

optionsFilename = 'custom.py'

if compilerIntel():
	Tool('icl')(commonEnvironment)
	optionsFilename = 'custom-msvc.py'
elif compilerMicrosoft():
	optionsFilename = 'custom-msvc.py'
elif getPlatform() == 'win32':
	# On Windows, to exclude MSVC tools,
	# we have to force MinGW tools and then re-create
	# the environment from scratch.
	commonEnvironment = Environment(ENV = os.environ, tools = ['mingw', 'swig', 'javac', 'jar'])
	commandOptions.Update(commonEnvironment)
	#Tool('mingw')(commonEnvironment)
	optionsFilename = 'custom-mingw.py'

Help(commandOptions.GenerateHelpText(commonEnvironment))

if commonEnvironment['custom']:
    optionsFilename = commonEnvironment['custom']

Requires(optionsFilename, commonEnvironment)

print "Using options from '%s.'" % optionsFilename

fileOptions = Options(optionsFilename)
fileOptions.Add('customCPPPATH', 'List of custom CPPPATH variables')
fileOptions.Add('customCCFLAGS')
fileOptions.Add('customCXXFLAGS')
fileOptions.Add('customLIBS')
fileOptions.Add('customLIBPATH')
fileOptions.Add('customSHLINKFLAGS')
fileOptions.Add('customSWIGFLAGS')
fileOptions.Update(commonEnvironment)

customCPPPATH = commonEnvironment['customCPPPATH']
commonEnvironment.Prepend(CPPPATH = customCPPPATH)
customCCFLAGS = commonEnvironment['customCCFLAGS']
commonEnvironment.Prepend(CCFLAGS = customCCFLAGS)
customCXXFLAGS = commonEnvironment['customCXXFLAGS']
commonEnvironment.Prepend(CXXFLAGS = customCXXFLAGS)
customLIBS = commonEnvironment['customLIBS']
commonEnvironment.Prepend(LIBS = customLIBS)

=== InOut/CMakeLists.txt ===
# REAL TIME AUDIO AND MIDI

message(STATUS "")
message(STATUS "## REALTIME AUDIO AND MIDI ##")

option(USE_PULSEAUDIO "Build the PulseAudio I/O module" ON)
option(USE_PORTAUDIO "Build the PortAudio I/O module" ON)
option(USE_PORTMIDI "Build the PortMIDI I/O module" ON)
option(USE_JACK "Build the jack I/O module and opcodes" ON)
option(USE_ALSA "Build the ALSA I/O module" ON)
option(USE_COREAUDIO "Build the CoreAudio I/O module" ON)
option(USE_FLTK "Use FLTK for graphs and widget opcodes" ON)
option(BUILD_VIRTUAL_KEYBOARD "Build Virtual MIDI keyboard" ON)

# FIND LIBRARIES AND HEADERS

if(USE_ALSA)
    find_library(ALSA_LIBRARY asound)
    find_file(ALSA_HEADER alsa/asoundlib.h)
endif()
if(USE_PORTAUDIO)
    find_library(PORTAUDIO_LIBRARY portaudio)
    find_file(PORTAUDIO_HEADER portaudio.h)
endif()
if(USE_PORTMIDI)
    find_library(PORTMIDI_LIBRARY portmidi)
    find_library(PORTTIME_LIBRARY porttime)
    find_file(PORTMIDI_HEADER portmidi.h)
endif()
if(USE_JACK)
    find_library(JACK_LIBRARY jack)
    find_library(JACKDMP_LIBRARY jackdmp)
    find_file(JACK_HEADER jack/jack.h)
endif()
if(USE_PULSEAUDIO)
    find_library(PULSEAUDIO_LIBRARY pulse)
    find_library(PULSESIMPLE_LIBRARY pulse-simple)
    find_file(PULSEAUDIO_HEADER pulse/simple.h)
endif()
if(USE_COREAUDIO)
    find_path(COREAUDIO_INCLUDE_PATH CoreAudio.h)
    find_library(COREAUDIO_LIBRARY CoreAudio)
endif()
if(USE_FLTK OR BUILD_VIRTUAL_KEYBOARD)
    find_package(FLTK)
endif()

# BUILD TARGETS

check_deps(USE_COREAUDIO APPLE COREAUDIO_INCLUDE_PATH COREAUDIO_LIBRARY)
if(USE_COREAUDIO)
    make_plugin(rtcoreaudio rtcoreaudio.c)
    include_directories(${COREAUDIO_INCLUDE_PATH})
    target_link_libraries(rtcoreaudio ${COREAUDIO_LIBRARY})
endif()

check_deps(USE_ALSA ALSA_HEADER ALSA_LIBRARY PTHREAD_LIBRARY)
if(USE_ALSA) 
    set(rtalsa_LIBS 
        ${ALSA_LIBRARY} ${PTHREAD_LIBRARY} m)
    make_plugin(rtalsa rtalsa.c ${rtalsa_LIBS})
endif()

if(WIN32)
    message(STATUS "Building Windows MME plugin(rtwinmm).")
    set(rtwinmm_LIBS
        winmm gdi32 kernel32) # should probably do checks for these libs
    make_plugin(rtwinmm rtwinmm.c "${rtwinmm_LIBS}")
endif()


check_deps(USE_PULSEAUDIO PULSEAUDIO_HEADER PULSEAUDIO_LIBRARY PULSESIMPLE_LIBRARY)
if(USE_PULSEAUDIO)
    make_plugin(rtpulse rtpulse.c ${PULSEAUDIO_LIBRARY} ${PULSESIMPLE_LIBRARY})
endif()

check_deps(USE_PORTAUDIO PORTAUDIO_HEADER PORTAUDIO_LIBRARY)
if(USE_PORTAUDIO)
    set(rtpa_LIBS ${PORTAUDIO_LIBRARY})
    
    if(WIN32)
        list(APPEND rtpa_LIBS winmm dsound ${CSOUND_WINDOWS_LIBRARIES})
    endif()

    make_plugin(rtpa rtpa.c ${rtpa_LIBS})
endif()

check_deps(USE_PORTMIDI PORTMIDI_HEADER PORTMIDI_LIBRARY)
if(USE_PORTMIDI)
    set(pmidi_LIBS ${PORTMIDI_LIBRARY})
    if(NOT APPLE)
        list(APPEND pmidi_LIBS ${PORTTIME_LIBRARY})
    endif()
    if(WIN32)
        list(APPEND pmidi_LIBS ${CSOUND_WINDOWS_LIBRARIES})
    endif()
    if(LINUX AND ALSA_LIBRARY)
        list(APPEND pmidi_LIBS ${ALSA_LIBRARY})
    endif()
    make_plugin(pmidi pmidi.c "${pmidi_LIBS}")
endif()

check_deps(USE_JACK JACK_HEADER JACK_LIBRARY)
if(USE_JACK)
    set(rtjack_LIBS "")
    if(LINUX)
        list(APPEND rtjack_LIBS 
            ${JACK_LIBRARY} ${PTHREAD_LIBRARY})
    elseif(WIN32)
        list(APPEND rtjack_LIBS
            ${JACKDMP_LIBRARY} ${PTHREAD_LIBRARY})
    else()
        list(APPEND rtjack_LIBS
            ${JACK_LIBRARY} ${PTHREAD_LIBRARY})
    endif()
    make_plugin(rtjack rtjack.c "${rtjack_LIBS}")
endif()

check_deps(USE_FLTK FLTK_FOUND)
if(USE_FLTK)
    set(widgets_SRCS FL_graph.cpp winFLTK.c widgets.cpp)
    make_plugin(widgets "${widgets_SRCS}" "${FLTK_LIBRARIES}")
endif()

check_deps(BUILD_VIRTUAL_KEYBOARD FLTK_FOUND)
if(BUILD_VIRTUAL_KEYBOARD)
    set(virtual_SRCS virtual_keyboard/FLTKKeyboard.cpp
        virtual_keyboard/FLTKKeyboardWindow.cpp
        virtual_keyboard/FLTKKeyboardWidget.cpp
        virtual_keyboard/virtual_keyboard.cpp
        virtual_keyboard/Bank.cpp
        virtual_keyboard/KeyboardMapping.cpp
        virtual_keyboard/Program.cpp
        virtual_keyboard/SliderBank.cpp
        virtual_keyboard/SliderData.cpp)
    make_plugin(virtual "${virtual_SRCS}" "${FLTK_LIBRARIES}")
    include_directories(".")
    include_directories(${FLTK_INCLUDE_DIR})
endif()

message(STATUS "")

=== Opcodes/CMakeLists.txt ===
## OPCODE LIBS WITH NO EXTERNAL DEPENDENCIES ##

set(stdopcod_SRCS 
    ambicode.c      bbcut.c         biquad.c
    butter.c        clfilt.c        cross2.c
    dam.c           dcblockr.c      filter.c
    flanger.c       follow.c        fout.c
    freeverb.c      ftconv.c        ftgen.c
    gab/gab.c       gab/vectorial.c grain.c
    locsig.c        lowpassr.c      metro.c
    midiops2.c      midiops3.c      newfils.c
    nlfilt.c        oscbnk.c        pluck.c
    repluck.c       reverbsc.c      seqtime.c
    sndloop.c       sndwarp.c       space.c
    spat3d.c        syncgrain.c     ugens7.c
    ugens9.c        ugensa.c        uggab.c
    ugmoss.c        ugnorman.c      ugsc.c
    wave-terrain.c  stdopcod.c)

make_plugin(stdopcod "${stdopcod_SRCS}" ${LIBSNDFILE_LIBRARY} m)
if(HAVE_VALUES_H)
    set_target_properties(stdopcod PROPERTIES COMPILE_FLAGS "-DHAVE_VALUES_H")
endif()

make_plugin(modmatrix modmatrix.c)
make_plugin(eqfil eqfil.c m)
make_plugin(pvsbuffer pvsbuffer.c)
make_plugin(scoreline scoreline.c)
make_plugin(mixer mixer.cpp)
make_plugin(signalflowgraph signalflowgraph.cpp)

set(modal4_SRCS 
    modal4.c physutil.c)
make_plugin(modal4 "${modal4_SRCS}" m)

set(physmod_SRCS 
    physmod.c physutil.c 
    mandolin.c singwave.c
    fm4op.c moog1.c shaker.c bowedbar.c)
make_plugin(physmod "${physmod_SRCS}" m)


set(pitch_SRCS 
    pitch.c pitch0.c spectra.c)    
make_plugin(pitch "${pitch_SRCS}" m)


make_plugin(barmodel bilbar.c m)
make_plugin(compress compress.c m)
make_plugin(grain4 grain4.c)
make_plugin(loscilx loscilx.c m)
make_plugin(minmax minmax.c)
make_plugin(cs_pan2 pan2.c m)
make_plugin(phisem phisem.c m)

set(pvoc_SRCS 
    dsputil.c pvadd.c pvinterp.c pvocext.c
    pvread.c ugens8.c vpvoc.c pvoc.c)
make_plugin(pvoc "${pvoc_SRCS}" m)

set(cs_pvs_ops_SRCS
    ifd.c partials.c psynth.c pvsbasic.c
    pvscent.c pvsdemix.c pvs_ops.c pvsband.c)
make_plugin(cs_pvs_ops "${cs_pvs_ops_SRCS}" m)

make_plugin(stackops stackops.c)
make_plugin(vaops vaops.c)
make_plugin(ugakbari ugakbari.c m)
make_plugin(harmon harmon.c m)
make_plugin(ampmidid ampmidid.cpp)
make_plugin(cs_date date.c)
make_plugin(system_call system_call.c)
make_plugin(ptrack pitchtrack.c m)
make_plugin(mutexops mutexops.cpp)
make_plugin(partikkel partikkel.c m)
make_plugin(shape shape.c m)
make_plugin(doppler doppler.cpp)
make_plugin(tabsum tabsum.c)
make_plugin(crossfm crossfm.c m)
make_plugin(pvlock pvlock.c m)
make_plugin(vosim Vosim.c)
make_plugin(tabfns tabvars.c)

set(gabnew_SRCS
    gab/tabmorph.c      gab/hvs.c
    gab/sliderTable.c   gab/newgabopc.c)
make_plugin(gabnew "${gabnew_SRCS}" m)

make_plugin(hrtfnew hrtfopcodes.c m)
if(BIG_ENDIAN)
    set_target_properties(hrtfnew PROPERTIES
        COMPILE_DEFINITIONS "WORDS_BIGENDIAN")
endif()

# temporarily do not build on Windows until these opcodes are fixed
# to compile
if(NOT WIN32) 
    make_plugin(udprecv sockrecv.c)
    make_plugin(udpsend socksend.c)
endif()


make_plugin(ftest ftest.c m)
make_plugin(ambicode1 ambicode1.c m)
make_plugin(babo babo.c m)
make_plugin(hrtferX hrtferX.c m)

set(vbap_SRCS 
    vbap.c vbap_eight.c vbap_four.c
    vbap_sixteen.c vbap_zak.c)
make_plugin(vbap "${vbap_SRCS}" m)

set(scansyn_SRCS
    scansyn.c scansynx.c)
make_plugin(scansyn "${scansyn_SRCS}" m)

if(UNIX)
    make_plugin(control control.c)
endif()

if(LINUX)
    make_plugin(cpumeter cpumeter.c)
endif()

## OPCODES WITH EXTERNAL DEPENDENCIES ##

# OGG Opcode previously was built only for OLPC
#if(VORBISFILE_LIBRARY)
#    set(vorbis_LIBS ${libcsound_LIBS} ${VORBISFILE_LIBRARY})
#    make_plugin(ogg ogg.c "${vorbis_LIBS}")
#endif()



set(sfont_FLAGS "")

if(CMAKE_C_COMPILER MATCHES "gcc")
    set(sfont_FLAGS ${sfont_FLAGS} -fno-strict-aliasing)
endif()
if(BIG_ENDIAN)
    set(sfont_FLAGS ${sfont_FLAGS} -DWORDS_BIGENDIAN)
endif()
message(STATUS "Compiler flags used for sfont lib: ${sfont_FLAGS}")
make_plugin(sfont sfont.c m)
set_target_properties(sfont
    PROPERTIES COMPILER_FLAGS "${sfont_FLAGS}")

    
          

#if mpafound==1:
#  makePlugin(pluginEnvironment, 'mp3in', ['mp3in.c'])
#if wiifound==1:
#  WiiEnvironment = pluginEnvironment.Clone()
#  makePlugin(WiiEnvironment, 'wiimote', ['wiimote.c'])
#if p5gfound==1:
#  P5GEnvironment = pluginEnvironment.Clone()
#  makePlugin(P5GEnvironment, 'p5g', ['p5glove.c'])

=== frontends/CMakeLists.txt ===
find_package(FLEX)
find_package(BISON)

## Csound Commandline Executable ##
set(CS_MAIN_SRCS csound/csound_main.c)
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    list(APPEND CS_MAIN_SRCS csound/sched.c)
endif()


# We need a different name to avoid clashes with float libcsound
make_executable(csound-bin "${CS_MAIN_SRCS}" "${CSOUNDLIB}" csound)

message(STATUS "Building csLadspa")
make_plugin(csladspa "csladspa/csladspa.cpp" "${CSOUNDLIB}")
# We do not want the lib prefix
set_target_properties(csladspa PROPERTIES PREFIX "")

# TCL interface

option(BUILD_TCLCSOUND "Build the tcl interface and clients" ON)

if(BUILD_TCLCSOUND)
    set(TCL_VERSION "" CACHE STRING "Try a specific tcl/tk version first")
    set(TCL_LIBRARY "tcl${TCL_VERSION}")
    set(TK_LIBRARY "tk${TCL_VERSION}")
    find_package(TCL)
endif()
check_deps(BUILD_TCLCSOUND TCL_FOUND TK_FOUND)
if(BUILD_TCLCSOUND)
    include_directories(${TCL_INCLUDE_PATH} ${TK_INCLUDE_PATH})
    make_executable(cstclsh "tclcsound/main_tclsh.c;tclcsound/commands.c" "${CSOUNDLIB};${TCL_LIBRARY}")
    make_executable(cswish "tclcsound/main_wish.c;tclcsound/commands.c" "${CSOUNDLIB};${TCL_LIBRARY};${TK_LIBRARY}")
    add_library(tclcsound SHARED tclcsound/tclcsound.c tclcsound/commands.c)
    target_link_libraries(tclcsound ${CSOUNDLIB} ${TCL_LIBRARY})
    set_target_properties(tclcsound PROPERTIES
        LINK_INTERFACE_LIBRARIES ""
        PREFIX ""
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

    install(TARGETS tclcsound cswish cstclsh
        LIBRARY DESTINATION "${LIBRARY_INSTALL_DIR}"
        ARCHIVE DESTINATION "${LIBRARY_INSTALL_DIR}"
        RUNTIME DESTINATION "${EXECUTABLE_INSTALL_DIR}")

endif()

# CSBeats

option(BUILD_CSBEATS "Build the beats score frontend" ON)
check_deps(BUILD_CSBEATS FLEX_EXECUTABLE BISON_EXECUTABLE)

if(BUILD_CSBEATS)
    
    BISON_TARGET(csbeats_PARSER beats/beats.y ${CMAKE_CURRENT_BINARY_DIR}/beats.tab.c)
    FLEX_TARGET(csbeats_SCANNER beats/beats.l ${CMAKE_CURRENT_BINARY_DIR}/lex.yy.c)

    ADD_FLEX_BISON_DEPENDENCY(csbeats_SCANNER csbeats_PARSER)

    include_directories(${CMAKE_CURRENT_BINARY_DIR})

    set(csbeats_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/beats/main.c
        ${FLEX_csbeats_SCANNER_OUTPUTS}
        ${BISON_csbeats_PARSER_OUTPUTS})

    make_executable(csbeats "${csbeats_SRCS}" "m")
    
endif()

add_subdirectory(CsoundAC)

=== interfaces/CMakeLists.txt ===
## Language bindings ##

# C++ INTERFACE LIBRARY

option(BUILD_CXX_INTERFACE "Build the C++ interface library" ON)
option(BUILD_PYTHON_INTERFACE "Build the Python interface (needs BUILD_CXX_INTERFACE)" ON)
option(BUILD_JAVA_INTERFACE "Build the Java interface (needs BUILD_CXX_INTERFACE)" ON)
option(BUILD_LUA_INTERFACE "Build the Lua interface (needs BUILD_CXX_INTERFACE)" ON)

if(BUILD_CXX_INTERFACE)
    message(STATUS "Building C++ interface library")
    set(libcsnd_SRCS
        CppSound.cpp
        CsoundFile.cpp
        Soundfile.cpp
        csPerfThread.cpp
        cs_glue.cpp
        filebuilding.cpp)
    set(libcsnd_LIBS ${LIBSNDFILE_LIBRARY})
    set(libcsnd_CFLAGS "")
    list(APPEND libcsnd_LIBS ${CSOUNDLIB})

    add_library(libcsnd SHARED ${libcsnd_SRCS})
    target_link_libraries(libcsnd ${libcsnd_LIBS})
    set_target_properties(libcsnd PROPERTIES
        LINK_INTERFACE_LIBRARIES ""
        SOVERSION ${APIVERSION}
        OUTPUT_NAME csnd
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        )
    if(${libcsnd_CFLAGS})
         set_target_properties(libcsnd PROPERTIES
             COMPILE_FLAGS ${libcsnd_CFLAGS})
    endif()

    install(TARGETS libcsnd
        LIBRARY DESTINATION "${LIBRARY_INSTALL_DIR}"
        ARCHIVE DESTINATION "${LIBRARY_INSTALL_DIR}")
    
endif()


# SWIG INTERFACES
FIND_PACKAGE(SWIG)
FIND_PACKAGE(PythonLibs)
FIND_PACKAGE(JNI)
FIND_PACKAGE(Java)
FIND_PACKAGE(Lua51)

check_deps(BUILD_PYTHON_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE PYTHONLIBS_FOUND)
check_deps(BUILD_JAVA_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE JNI_FOUND JAVA_FOUND)
check_deps(BUILD_LUA_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE LUA51_FOUND)

if(BUILD_PYTHON_INTERFACE OR BUILD_JAVA_INTERFACE OR BUILD_LUA_INTERFACE)

    include(${SWIG_USE_FILE})

    include_directories(${CMAKE_CURRENT_SOURCE_DIR})

    set(CMAKE_SWIG_FLAGS ${libcsound_CFLAGS})
    list(APPEND CMAKE_SWIG_FLAGS "-includeall" "-verbose")

    if(USE_DOUBLE)
        list(APPEND CMAKE_SWIG_FLAGS "-DUSE_DOUBLE")
    endif(USE_DOUBLE)

    set(CMAKE_SWIG_OUTDIR ${BUILD_LIB_DIR})

    if(BUILD_PYTHON_INTERFACE)
        INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})

        set(swigpython_LIBS ${PYTHON_LIBRARIES} ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd)
    
        SET_SOURCE_FILES_PROPERTIES(python_interface.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME csnd)
        SWIG_ADD_MODULE(csnd python python_interface.i)
        SWIG_LINK_LIBRARIES(csnd ${swigpython_LIBS})
    
        set_target_properties(${SWIG_MODULE_csnd_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

        install(TARGETS ${SWIG_MODULE_csnd_REAL_NAME}
            LIBRARY DESTINATION "${PYTHON_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${PYTHON_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/csnd.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})

    endif()

    if(BUILD_JAVA_INTERFACE)
        # The java package needs this unset or it will litter us with .java files
        unset(CMAKE_SWIG_OUTDIR)
        INCLUDE_DIRECTORIES(${JNI_INCLUDE_DIRS})
        set(swigjava_LIBS ${JNI_LIBRARIES} ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd)

        SET_SOURCE_FILES_PROPERTIES(java_interface.i PROPERTIES CPLUSPLUS ON)
        SET_SOURCE_FILES_PROPERTIES(java_interface.i SWIG_FLAGS "-package" "csnd")
        SWIG_ADD_MODULE(_jcsound java java_interface.i)
        SWIG_LINK_LIBRARIES(_jcsound ${swigjava_LIBS})

        ADD_CUSTOM_COMMAND(TARGET _jcsound
            POST_BUILD
            COMMAND cmake -E make_directory ./csnd
            COMMAND ${JAVA_COMPILE} *.java -d ./csnd
            COMMAND ${JAVA_ARCHIVE} cf ../csnd.jar csnd
            COMMENT "Building JAVA package csnd.jar")

        set_target_properties(_jcsound PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

        install(TARGETS _jcsound
            LIBRARY DESTINATION "${JAVA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${JAVA_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/csnd.jar
            DESTINATION ${JAVA_MODULE_INSTALL_DIR})
    
    endif()

    if(BUILD_LUA_INTERFACE)
        INCLUDE_DIRECTORIES(${LUA_INCLUDE_DIR})

        set(swiglua_LIBS ${LUA_LIBRARIES} ${CSOUNDLIB} libcsnd)
    
        SET_SOURCE_FILES_PROPERTIES(lua_interface.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME luaCsnd)
        SWIG_ADD_MODULE(luaCsnd lua lua_interface.i)
        SWIG_LINK_LIBRARIES(luaCsnd ${swiglua_LIBS})
    
        set_target_properties(${SWIG_MODULE_luaCsnd_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            PREFIX "")

        install(TARGETS luaCsnd
            LIBRARY DESTINATION "${LUA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${LUA_MODULE_INSTALL_DIR}")

    endif()

endif()

=== util/CMakeLists.txt ===
# UTILITY PLUGIN AND PROGRAMS

set(stdutil_SRCS
    atsa.c          cvanal.c        dnoise.c    envext.c    
    het_export.c    het_import.c    hetro.c     lpanal.c 
    lpc_export.c    lpc_import.c    mixer.c     pvanal.c        
    pv_export.c     pv_import.c     pvlook.c    scale.c
    sndinfo.c       srconv.c        std_util.c  xtrct.c
    ../SDIF/sdif.c)

make_plugin(stdutil "${stdutil_SRCS}" m ${LIBSNDFILE_LIBRARY})

if(BUILD_UTILITIES) 
    make_utility(atsa        atsa_main.c)
    make_utility(cvanal      cvl_main.c)
    make_utility(dnoise      dnoise_main.c)
    make_utility(envext      env_main.c)
    make_utility(extractor   xtrc_main.c)
    make_utility(het_export  hetx_main.c)
    make_utility(het_import  heti_main.c)
    make_utility(hetro       het_main.c)
    make_utility(lpanal      lpc_main.c)
    make_utility(lpc_export  lpcx_main.c)
    make_utility(lpc_import  lpci_main.c)
    make_executable(mixer-bin   mixer_main.c   "${CSOUNDLIB}" mixer)
    make_utility(pvanal      pvc_main.c)
    make_utility(pvlook      pvl_main.c)
    make_utility(pv_export   pvx_main.c)
    make_utility(pv_import   pvi_main.c)
    make_utility(scale       scale_main.c)
    make_utility(sndinfo     sndinfo_main.c)
    make_utility(srconv      srconv_main.c)
endif()

=== frontends/CsoundAC/CMakeLists.txt ===
# Build CsoundAC

option(BUILD_CSOUND_AC "Build CsoundAC extension module for Csound with algorithmic composition (needs C++ interface)" ON)
option(BUILD_CSOUND_AC_PYTHON_INTERFACE "Build the Csound AC Python interface" ON)
option(BUILD_CSOUND_AC_LUA_INTERFACE "Build the Csound AC Lua interface" ON)


find_package(Boost)
find_library(MUSICXML_LIBRARY musicxml2)
find_package(FLTK)
find_package(SWIG)
find_package(PythonLibs)
find_package(Lua51)

check_deps(BUILD_CSOUND_AC Boost_FOUND BUILD_CXX_INTERFACE FLTK_FOUND LIBSNDFILE_LIBRARY)
check_deps(BUILD_CSOUND_AC_PYTHON_INTERFACE SWIG_FOUND PYTHONLIBS_FOUND)
check_deps(BUILD_CSOUND_AC_LUA_INTERFACE SWIG_FOUND LUA51_FOUND)

if(BUILD_CSOUND_AC)
    include_directories(${CMAKE_HOME_DIRECTORY}/interfaces)
    include_directories(${Boost_INCLUDE_DIRS})
    include_directories(${FLTK_INCLUDE_DIR})
    set(libcsoundac_SRCS 
        Cell.cpp
        ChordLindenmayer.cpp
        Composition.cpp
        Conversions.cpp
        Counterpoint.cpp
        CounterpointNode.cpp
        Event.cpp
        Hocket.cpp
        ImageToScore.cpp
        Lindenmayer.cpp
        MCRM.cpp
        Midifile.cpp
        MusicModel.cpp
        Node.cpp
        Random.cpp
        Rescale.cpp
        Score.cpp
        ScoreModel.cpp
        ScoreNode.cpp
        Sequence.cpp
        Shell.cpp
        Soundfile.cpp
        StrangeAttractor.cpp
        System.cpp
        Voicelead.cpp
        VoiceleadingNode.cpp)
    
    add_library(libCsoundAC SHARED ${libcsoundac_SRCS})
    set_target_properties(libCsoundAC PROPERTIES
        LINK_INTERFACE_LIBRARIES ""
        SOVERSION ${APIVERSION}
        OUTPUT_NAME CsoundAC
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        )
    target_link_libraries(libCsoundAC libcsnd ${FLTK_LIBRARIES} ${LIBSNDFILE_LIBRARY})
    
    if(MUSICXML_LIBRARY) 
        target_link_libraries(CsoundAC MUSICXML_LIBRARY)
    endif()

    if(SWIG_FOUND)
        include(${SWIG_USE_FILE})
        set(CMAKE_SWIG_OUTDIR ${BUILD_LIB_DIR})
        include_directories(${CMAKE_CURRENT_SOURCE_DIR})
    endif()

    if(BUILD_CSOUND_AC_PYTHON_INTERFACE)
        message(STATUS "Building CsoundAC Python interface")
        find_package(PythonLibs)
        include_directories(${PYTHON_INCLUDE_PATH})
        set_source_files_properties(CsoundAC.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME CsoundAC)
        swig_add_module(CsoundAC python CsoundAC.i)
        swig_link_libraries(CsoundAC libCsoundAC ${PYTHON_LIBRARIES})

        set_target_properties(${SWIG_MODULE_CsoundAC_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

        install(TARGETS ${SWIG_MODULE_CsoundAC_REAL_NAME}
            LIBRARY DESTINATION "${PYTHON_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${PYTHON_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/CsoundAC.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})
    endif()

    if(BUILD_CSOUND_AC_LUA_INTERFACE)
        message(STATUS "Building CsoundAC Lua interface")
        find_package(Lua51)
        include_directories(${LUA_INCLUDE_DIR})

        SET_SOURCE_FILES_PROPERTIES(luaCsoundAC.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME luaCsoundAC)
        SWIG_ADD_MODULE(luaCsoundAC lua luaCsoundAC.i)
        SWIG_LINK_LIBRARIES(luaCsoundAC libCsoundAC ${LUA_LIBRARIES})

        set_target_properties(${SWIG_MODULE_luaCsoundAC_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            PREFIX "")

        install(TARGETS luaCsoundAC
            LIBRARY DESTINATION "${LUA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${LUA_MODULE_INSTALL_DIR}")
    endif()

endif()

=== frontends/beats/Makefile ===
SRC = beats.tab.c lex.yy.c main.c
OBJ = beats.tab.o lex.yy.o main.o

all:	csbeats

csbeats:	$(OBJ)
	gcc -g -o csbeats $(OBJ) -lm

lex.yy.c:	beats.l beats.tab.h
	flex beats.l

lex.yy.o:	lex.yy.c beats.tab.h
	gcc -g -c lex.yy.c

beats.tab.c:	beats.y
	bison -d beats.y

beats.tab.o:	beats.tab.c
	gcc -g -c beats.tab.c

main.o:	main.c
	gcc -g -c main.c

clean:
	rm -rf main.o beats.tab.o beats.tab.c beats.tab.h lex.yy.o lex.yy.c \
	beats makefile

dist:
	zip beats.zip  beats.l  beats.y main.c Makefile test.xs

makefile: Makefile $(SRC)
	gcc -M $(SRC) | cat Makefile - > makefile

=== util2/envext/Makefile ===
#								scale Makef
# macros passed from csound/Makefile
#	CFLAGS INCLUDE LIB DEST

INCLUDE	= ${prefix}/include
LIB	= ${prefix}/share
DEST	= ${exec_prefix}/bin
CFLAGS  = -g -O2 -Wall -malign-loops=4 -malign-jumps=4 -ffast-math -fomit-frame-pointer -finline-functions -funroll-loops -DWITHx87 $(DEFINES)
LIBS    = -L/usr/local/lib -lfltk -L/usr/X11R6/lib -lm -lXext -lX11 -lm -lpthread -lstdc++  -L/usr/X11R6/lib -lm -lpthread -lpthread -lX11 -lportaudio -lasound -ldl -lc 

T = ../..

INC = ../..

OBJS =	$T/sndinfo.$OBJEXT$ $T/filopen.$OBJEXT$ $T/sfheader.$OBJEXT$ \
	$T/soundin.$OBJEXT$ $T/memalloc.$OBJEXT$ $T/wave.$OBJEXT$ \
	$T/aiff.$OBJEXT$ $T/aifc.$OBJEXT$ $T/ieee80.$OBJEXT$ \
	$T/ulaw.$OBJEXT$ $T/getstring.$OBJEXT$

envext:		envext.$OBJEXT$ $(OBJS)
		gcc $(CFLAGS) envext.$OBJEXT$ $(OBJS) -lm -o envext

envext.$OBJEXT$:	envext.c ../../cs.h ../../ustub.h ../../soundio.h
		gcc -I ../../H $(CFLAGS) -I$(INC) -c envext.c

install:	envext
		-strip envext
		rm -f $(DEST)/envext
		cp envext $(DEST)

clean:		rmbak
		-rm envext

rmbak:
		-rm *.bak *~

=== debian/changelog ===
csound (1:5.14.2~dfsg-2) unstable; urgency=low

  * Fix broken lua module symlink (symlink did not get updated when the lua
    module changed names).
  * Fix FTBFS with -Werror=format-security. Closes: #649462

 -- Felipe Sateler <fsateler@debian.org>  Wed, 23 Nov 2011 22:06:19 -0300

csound (1:5.14.2~dfsg-1) unstable; urgency=low

  [ Felipe Sateler ]
  * New upstream release
   - Update copyright file
   - Remove patch applied upstream
   - Refresh patches
   - Beats has been renamed to csbeats
  * Delete custom.py on clean
  * Install new plugins
  * Enable the new Lua opcodes
  * Enable new parser

  [ Jonas Smedegaard ]
  * Update copyright file:
    + Rewrite to DEP5 rev. 174 format.
    + Fix update more entries.

 -- Felipe Sateler <fsateler@debian.org>  Wed, 02 Nov 2011 19:56:26 -0300

csound (1:5.13.0~dfsg-5) unstable; urgency=low

  * Use linux-any wildcard for libasound dependency. Closes: #634489
  * Build only for the current python version.
     Closes: #642708

 -- Felipe Sateler <fsateler@debian.org>  Sun, 25 Sep 2011 16:19:59 -0300

=== debian/control ===
Source: csound
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Felipe Sateler <fsateler@debian.org>, Jonas Smedegaard <dr@jones.dk>
Build-Depends: scons,
 debhelper,
 dh-buildinfo,
 python (>= 2.6.5),
 cdbs (>= 0.4.97~),
 devscripts,
 libsndfile1-dev,
 libasound2-dev [linux-any],
 libjack-dev,
 portaudio19-dev,
 libportmidi-dev,
 libpulse-dev,
 swig,
 liblua5.1-0-dev,
 tk-dev,
 tcl-dev,
 python-dev (>= 2.6.6-3~),
 puredata-dev,
 default-jdk,
 libfltk1.1-dev,
 libfluidsynth-dev,
 liblo-dev,
 fluid,
 ladspa-sdk,
 libboost-dev,
 libboost-serialization-dev,
 libpng12-dev,
 dssi-dev,
 libstk0-dev,
 libgmm++-dev,
 bison,
 flex,
 doxygen,
 graphviz,
 ttf-dejavu
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-multimedia/csound
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/csound.git;a=summary
Homepage: http://www.csounds.com

Package: csound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libcsound64-5.1 (<< 1:5.08.2~dfsg-1)
Recommends: csound-gui, csound-utils, csound-manpages
Description: powerful and versatile sound synthesis software
 Csound is a sound and music synthesis system. Drawing from over 450
 signal processing modules, it can be used to model virtually any
 synthesizer or multi-effect processor. It can work either in real-time
 or as a compiler.
 .
 Csound is to sound synthesis as C is to programming.

Package: csound-data
Architecture: all
Depends: ${misc:Depends}
Breaks: csound (<< 1:5.13.0~dfsg-4)
Description: data files used by the csound library
 This package includes the architecture-independent data files used by
 the csound library or plugins.
 .
 For more information on Csound see the csound package.

Package: csound-gui
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: GUI interfaces and opcodes for Csound
 This package includes the GUI interfaces for Csound: winsound,
 cseditor and csound5gui, plus the GUI opcodes.
 .
 For more information on Csound, see the csound package.

Package: csound-utils
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: miscellaneous utilities for the Csound system
 This package contains several utilities which may be useful with
 Csound.
 These utilities aid in score creation, sound analysis and sound 
 transformations.

Package: libcsound64-5.2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, csound-data
Recommends: csound
Breaks: csound (<< 1:5.07.0.dfsg-1)
Description: main library for Csound
 This package contains the library which provides most of the Csound
 functionality. This library was built using 64-bit precision for the
 calculations (this doesn't mean you need a 64-bit processor).
 .
 For more information on Csound, see the csound package.

Package: libcsnd-java
Architecture: any
Section: java
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: csound
Suggests: java-virtual-machine
Description: Java bindings for the Csound API
 These are the java bindings for the Csound API.
 .
 For more information on Csound, see the csound package

Package: libcsound64-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsound64-5.2 (>= ${source:Version}), libcsound64-5.2 (<< ${source:Version}.1~), ${misc:Depends}
Description: development files for Csound
 This package contains the development files needed to build programs
 linking to the Csound library.
 .
 For more information on Csound, see the csound package.

Package: libcsnd-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsnd5.2 (>= ${source:Version}), libcsnd5.2 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsnd5.1
Suggests: liblua5.1-luacsnd5.2
Provides: liblua5.1-luacsnd-dev
Description: development files for Csound -- C++ API
 This package contains the development files needed to build programs
 using the C++ bindings to the Csound library. It also includes the
 development symlink for the lua module, but you have to manually
 install liblua5.1-luacsnd5.2 for that to work.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsoundac5.2 (>= ${source:Version}), libcsoundac5.2 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsoundac5.1
Description: development files for CsoundAC
 This package contains the development files needed to build programs
 using the CsoundAC algorithmic composition system.
 .
 For more information on Csound and CsoundAC, see the csound and
 csoundac packages.

Package: pd-csound
Architecture: any
Depends: csound, puredata | pd, ${shlibs:Depends}, ${misc:Depends}
Description: Csound external for PureData
 This is the csoundapi~ opcode for PureData.
 .
 For more information on Csound or pureData, see the respective
 packages.

Package: python-csound
Architecture: any
Section: python
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for Csound
 This is the Python binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: libcsnd5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ bindings for the Csound API
 This is the C++ binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: liblua5.1-luacsnd5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: liblua5.1-csnd
Description: Lua bindings for the Csound API
 This is the Lua binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: tclcsound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tcl bindings and interpreters for Csound
 This package contains the Tcl interfaces to Csound. It includes:
  - tclcsound: the Csound Tcl interface.
  - cswish: Csound wish interpreter
  - cstclsh: Csound Tcl interpreter
 .
 For more information on Csound or Tcl, see the respective packages.

Package: libcsoundac5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: the Csound Algorithmic Composition library
 This is the core library for CsoundAC. It provides all the CsoundAC
 functionality. It also contains the development files to create C++
 programs.
 .
 For more information on Csound, see the csound package.

Package: python-csoundac
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, python-csound, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for CsoundAC
 This is the Python interface to the Csound Algorithmic Composition
 library.
 .
 For more information on Csound, see the csound package.

Package: csladspa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ladspa-plugin
Description: LADSPA plugin for Csound
 This plugin enables the creation of LADSPA plugins with the Csound
 language.
 .
 For more information on Csound or LADSPA, see the csound or ladspa-sdk
 packages, respectively.

Package: libcsound64-doc
Architecture: all
Priority: extra
Section: doc
Depends: ${misc:Depends}
Recommends: csound, libcsound64-dev
Description: Csound API documentation
 This package contains the API documentation for the Csound library in
 HTML format.
 .
 For more information on Csound, see the csound package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2007-2009 Felipe Sateler <fsateler@gmail.com>
# Copyright © 2008-2010 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for CSound
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DEB_PYTHON_MODULE_PACKAGES = python-csound python-csoundac
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-module.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_UPSTREAM_URL = http://downloads.sourceforge.net/csound

# Adjustments for unusual upstream tarballs:
# * capitalized project name
# * no dash between project name and version
# * version number included in top folder inside tarball
DEB_UPSTREAM_PACKAGE = Csound
DEB_UPSTREAM_TARBALL_BASENAME_MANGLE = s/\-//g

DEB_UPSTREAM_TARBALL_MD5 = 053c364620b778ab5def18d0f8c4db48

# Non-DFSG license: limited to educational and research purposes
DEB_UPSTREAM_REPACKAGE_EXCLUDES = ./Opcodes/scansyn*
# Embedded tarball contains possibly source-less python binary
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./csound5_osx_installer_files.tar.gz
# Contains explicit copyright but lack licensing info
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./samples/VintageDreamsWaves-v2.sf2

# Common docs for all packages
DEB_INSTALL_DOCS_ALL = readme-csound5.txt AUTHORS

# Core options of csound
DEB_SCONS_OPTIONS = \
	dynamicCsoundLibrary=1 \
	useDouble=1 \
	buildNewParser=1 \
	NewParserDebug=0 \
	buildMultiCore=0 \
	useGettext=1 \
	buildRelease=1 \
	buildUtilities=1 \
	noDebug=0 \
	useLrint=0 \
	Word64=0 \
	Lib64=0 \
	useAltivec=0 \
	useOpenMP=0 \
	withICL=0 \
	withMSVC=0 \
	withSunStudio=0 \
	prefix=/usr \
	generatePdf=0 \
	generateTags=0 \
	bufferoverflowu=0 \
	buildCatalog=0 \
	includeSerial=0 \
	LINKFLAGS='-Wl,-as-needed' \
	SHLINKFLAGS='-Wl,-as-needed'

# I/O plugins
DEB_SCONS_OPTIONS += \
	useCoreAudio=0 \
	usePortAudio=1 \
	usePortMIDI=1 \
	useJack=1 \
	buildVirtual=1  # Virtual MIDI keyboard
# PulseAudio does not have an option
ifeq "$(DEB_HOST_ARCH_OS)" "linux"
	DEB_SCONS_OPTIONS += useALSA=1
else
	DEB_SCONS_OPTIONS += useALSA=0
endif

# Optional opcodes
DEB_SCONS_OPTIONS += \
	useFLTK=1 \
	noFLTKThreads=1 \
	useOSC=1 \
	buildPythonOpcodes=1 \
	buildDSSI=1 \
	buildLoris=0 \
	useUDP=1 \
	buildStkOpcodes=1 \
	buildvst4cs=0 \
	includeMP3=0 \
	includeWii=0 \
	includeP5Glove=0 \
	buildImageOpcodes=1

# Language Wrappers
# TODO: build for all Python versions (not only current default one)
# Force build of only the default one
# UGLY HACK: abuse this variable to pass an appropriate -V option
DEB_DH_PYTHONHELPER_ARGS_ALL = -V $(shell pyversions -vd)
TCLVERSION := $(shell dpkg -l tcl-dev | sed -n 's/.*\(8\.[45]\)\..*/\1/p')
DEB_SCONS_OPTIONS += \
	buildInterfaces=1 \
	buildJavaWrapper=1 \
	buildPythonWrapper=1 \
	pythonVersion=$(cdbs_python_current_version) \
	buildLuaWrapper=1 \
	buildLuaOpcodes=1 \
	buildTclcsound=1 \
	tclversion=$(TCLVERSION) \
	buildPDClass=1

# Frontends
DEB_SCONS_OPTIONS += \
	buildBeats=1 \
	buildCSEditor=0 \
	buildCsoundAC=1 \
	buildCsoundVST=0 \
	buildCsound5GUI=0 \
	buildOSXGUI=0 \
	buildWinsound=1


# This is a huge optimization boost
ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	DEB_SCONS_OPTIONS += gcc4opt=generic
endif

# Python >= 2.6 should install to dist-packages instead of site-packages
# Since 2.5 is the only version < 2.6 we support, we test for that.
# TODO: Use simpler second form when 2.6 is default in a stable release
PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/$(if $(call cdbs_streq,$(cdbs_python_current_version),2.5),site-packages,dist-packages)
#PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/dist-packages

CC = $(DEB_HOST_GNU_TYPE)-gcc
CXX = $(DEB_HOST_GNU_TYPE)-g++

# Support parallel building if enabled in DEB_BUILD_OPTIONS
NJOBS = $(DEB_PARALLEL_JOBS:%=-j%)

DEB_DH_INSTALL_SOURCEDIR = debian/tmp

fltk-orig-files := $(shell find * -type f -name '*.fl')
fltk-autofiles = $(fltk-orig-files:.fl=.cpp) $(fltk-orig-files:.fl=.cxx) $(fltk-orig-files:.fl=.hpp) $(fltk-orig-files:.fl=.h)
swig-autofiles = interfaces/python_interface_wrap.cc interfaces/python_interface_wrap.h
upstreamtmpfiles = custom.py $(fltk-autofiles) $(swig-autofiles) doc/latex/doxygen.sty

common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl::
	cp --remove-destination debian/custom.py custom.py

DEB_SCONS_BUILD_OPTIONS = $(NJOBS)

DEB_SCONS_INSTALL_OPTIONS = instdir=$(CURDIR)/debian/tmp
DEB_SCONS_INSTALL_TARGET = install=1


install/libcsound64-doc:: build-doxygen-stamp
build-doxygen-stamp:
	doxygen
	touch $@

# Put aside upstream cruft before build but after licensecheck
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff:
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || mv -v $$file $$file.upstream; \
	done
	for dir in $(upstreamtmpdirs); do \
		[ ! -e $$dir ] || [ -e $$dir.upstream ] || mv -v $$dir $$dir.upstream; \
	done
	touch $@

# Revert upstream cruft that was put aside during build
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -v -f $$file.upstream $$file; \
	done
	for dir in $(upstreamtmpdirs); do \
		[ ! -e $$dir.upstream ] || mv -v -f $$dir.upstream $$dir; \
	done
	rm -f debian/stamp-upstreamtmpstuff

clean::
	rm -f build-arch-stamp build-indep-stamp manpages-stamp \
		build-doxygen-stamp
	rm -f custom.py
# and there still is stuff that doesn't get deleted.
	rm -f interfaces/*.java
	rm -f interfaces/*_interface_wrap.*
	rm -f frontends/CsoundVST/CsoundVST_wrap.h
	rm -f frontends/CsoundAC/CsoundAC_wrap.h
	rm -f lib_CsoundVST.so CsoundVST.py
	rm -f libcsound64.so
	rm -f libcsound64.so.5
	rm -f frontends/cseditor/cseditor.o
	rm -f libcsnd.so
	rm -f CsoundAC.py lib_CsoundAC.so
	rm -f frontends/CsoundAC/*.os
	rm -f libCsoundAC.so*
	rm -rf doc/html
	rm -f csnd.py
	rm -f Engine/csound_orcparse.output
# Localisation stuff
	rm -rf po/*/
# fail-missing stuff
	rm -f debian/cdbs-install-diff
	rm -f debian/cdbs-reduced-install-list
	rm -f debian/cdbs-reduced-package-list

install/csound-data::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/locale
	cp -r po/*/ $(CURDIR)/debian/tmp/usr/share/locale
	mkdir -p $(CURDIR)/debian/tmp/usr/share/csound/hrtf
	cp samples/*.dat $(CURDIR)/debian/tmp/usr/share/csound/hrtf

# Scons sucks
install/libcsound64-dev::
	ln -sf libcsound64.so.* $(CURDIR)/debian/tmp/usr/lib/libcsound64.so

# avoid conflict with extract
install/csound-utils::
	mv $(CURDIR)/debian/tmp/usr/bin/extract \
		$(CURDIR)/debian/tmp/usr/bin/csound_extract

install/pd-csound::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/pd/extra
	mv $(CURDIR)/debian/tmp/usr/lib/csoundapi~.pd_linux \
		$(CURDIR)/debian/tmp/usr/lib/pd/extra

install/libcsnd-java::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/java
	mv $(CURDIR)/debian/tmp/usr/lib/csnd.jar \
		$(CURDIR)/debian/tmp/usr/share/java/csnd-$(DEB_UPSTREAM_VERSION).jar
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/jni
	mv $(CURDIR)/debian/tmp/usr/lib/lib_jcsound.so \
		$(CURDIR)/debian/tmp/usr/lib/jni

install/python-csound::
	mkdir -p $(CURDIR)/debian/tmp/$(PYLIBPATH)
	cp csnd.py _csnd.so \
		$(CURDIR)/debian/tmp/$(PYLIBPATH)

install/liblua5.1-luacsnd5.2::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/lua/5.1/
	install luaCsnd.so $(CURDIR)/debian/tmp/usr/lib/liblua5.1-luacsnd.so.5.2
